% Diffusor med blader
% Halvor Haugsvold 2010


clear all
close all
clc
% Parametere
rho         = 1.2;
Q           = 3000/3600;
cm0         = 6.6;
cu0         = 13.1;
c0          = sqrt(cu0^2 + cm0^2);
r0          = 0.183;  
b0          = 0.11;
const       = cu0*r0; 
diffradius  = 0.283;
R           = 0.8;                     %Hastighetsratio over innlp
zteo        = Q/(b0*const*log(1/R));    %Teoretisk antall blad, Q, R
z           = round(zteo);              %Avrunda antall blad
ekspv       = 5;                        %halvvinkel ekspansjon

%Vektorer
r=          [];
tetta=      [];
buelengde=  [];
bredde=     [];

%Initialbetingelser
r(1) =      r0;
tetta(1) =  0;

%Bue
i=2;
while r(i-1) < diffradius;
    tetta(i) = tetta(i-1) + 0.1*pi/180;
    r(i) = exp(log(r0) + (tetta(i)/(2*pi))/(b0*const));
    i=i+1;
end

iter=i-1;

%Normal p alfa
falfa  = atand(cm0/cu0);
for i = 1:iter
    
    fr(i)       =  sqrt(r(i)^2 + tand(falfa)*(r(i)-r0)^2);
    ftetta(i)   =  (360/z)*(pi/180) - atan( (r(i) - r0)*tand(falfa)/r(i)) ;
         
end
xfr(:,1) = fr;
xfr(:,2) = ftetta;
xr (:,1) = r;
xr (:,2) = tetta;

smalltetta = abs( xfr(:,2)-xr(:,2));
[margin,nummer] = min(smalltetta);

%Blader
for j = 1:z
    polar(tetta+j*2*pi/z,r)
   
    hold on
end
%Indre og ytre radius
t=0:pi/32:2*pi;
x(1:65) = r0;
y(1:65) = diffradius;
polar(t,y,'r')
polar(t,x,'r')

%Kile
polar(ftetta(1:nummer),fr(1:nummer));
difftetta = tetta(nummer) - tetta(1);
diffr = r(nummer) - r(1);

kiler = r+diffr;
kiletetta = tetta+difftetta;
kile = length(find(kiler < diffradius));

for j = 1:z
    polar(kiletetta(1 : kile+1) + j*2*pi/z,kiler(1:kile+1));
    hold on
end

%Bredde -  i klokkeretning
%Buelengde
bredde(1) = b0/2
buelengde(1) = 0;
for i =2:iter-1;
buelengde(i) = buelengde(i-1) + r(i) * (tetta(i+1) - tetta(i));
bredde(i) = b0/2 + buelengde(i)*tand(ekspv);
end
bredde(iter) = bredde(iter-1);
A1 =  (r(nummer)-r(1)) * b0;
A2 = (r(nummer)-r(1)) * (b0 + 2*bredde(iter-1));

Arealratio = bredde(iter-1)/ bredde(1) -1
Arealratio2 = (A2-A1)/A1
deltap = rho/2*(Q/z)^2*(1/A1^2 + 1/A2^2)   
cute = sqrt( (const/r(nummer))^2 + cm0^2)
deltapinnlop = rho/2*(c0^2 - ((cute+c0)/2)^2)
c2 = (Q/z)/A2

deltap2 = rho/2*(((cute+c0)/2)^2 - c2^2)
buelengde(iter-1)
diffusorlengde = buelengde(length(r) -1) - buelengde(nummer)
diffusorbredde = r(nummer) - r(1)
lengderatio =    diffusorlengde /  buelengde(iter-1)
hold off
% figure()
% plot(bredde,r)

[X1,Y1] = pol2cart(tetta,r*1000);
[Xk1,Yk1] = pol2cart(kiletetta,kiler*1000);
m=1
for j = 1:10:i

X(m) = X1(j);
Y(m) = Y1(j);
Xk(m) = Xk1(j);
Yk(m) = Yk1(j);
Z(m) = bredde(j)* 1000;
R(m) = r(j) * 1000;
m = m + 1;
end

z

% xlswrite('hp.xls',X','A1:A42');
% xlswrite('hp.xls',Y','B1:B42');
% xlswrite('hp2.xls',Xk','A1:A42');
% xlswrite('hp2.xls',Yk','B1:B42');
% xlswrite('hp3.xls',R','A1:A42');
% xlswrite('hp3.xls',Z','B1:B42');

