% Diffusor uten blader
% Halvor Haugsvold 2010

clear all
close all
clc

%Parametere
rho = 1.2;
cm0         = 3.51;
cu0         = 10.08;
r0          = 0.183;  
b0          = 0.092488;
bredde      = 0.07; %diff radius
A0          = 2*pi*r0*b0;
const       = cu0*r0; 
Q           = cm0*2*pi*r0*b0;
n           = 0.005;
iter        = 30;

% Innlp---------------
cm=             [];
cu=             [];
alfa=           [];
r=              [];
tetta=          [];
c=              [];
fr =            [];
banelengde =    [];
A =             [];


%Initialverdier
cm(1) = cm0;
cu(1) = cu0;
r(1) = r0;
c(1) =  sqrt(cu(1)^2 + cm(1)^2); 
tetta(1) = 0;
b(1) = A0/(2*pi*r(1)); 
A(1) = 2*pi*r(1)*b(1);
banelengde(1) = 0;


%rr-analogi
imgr =          sqrt(2*r(1)*b(1));  %r som tilsvarer et rr
tet =           5;                  %ekspansjonsvinkel(halvvinkel) ( grader)

i = 2;
while r(i-1) < r0+bredde

    
    cm(i) =            Q/(2*pi*r(i-1)*b(i-1)) ;
    cu(i) =            const/r(i-1);
    c(i)  =            sqrt(cu(i)^2 + cm(i)^2); 
    m =                (cu(i)/cm(i))*n;
    r(i) =             sqrt(m^2 + (n+r(i-1))^2);
    banelengde(i) =     banelengde(i-1) + sqrt(m^2 + n^2);
    b(i) =             ((imgr + banelengde(i)*tand(tet))^2)/(2*r(i)); 
    tetta(i) =         tetta(i-1) + atan(m/(r(i-1) + n));
    A(i)    =          2*pi*r(i)*b(i);
    alfa(i)  =         atand(cm(i)/cu(i));
   
    i = i+1;
end

dp = rho/2*(c(1)^2 - c(i-1)^2)
banelengde(i-1)
% polar(tetta,r)
c(i-1)



%Indre og ytre radius
t=0:pi/32:2*pi;
x(1:65) = r0;
y(1:65) = r0+bredde;
polar(t,y,'r')
hold on
polar(t,x,'r')
polar(tetta,r)
% 
% 
% 
% 
A(1)/ A(i-1)
X = r*1000;
Z = b/2*1000;
% 
xlswrite('bladlaus2.xls',X','A1:A14');
xlswrite('bladlaus2.xls',Z','B1:B14');

vinkel = atand(abs((b(i-1)-b(1))/2)/(bredde))
figure(2)
plot(r,b/2)
axis([0.1 0.3 0 0.3]) 
